﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Tetris
{
    /// <summary>
    /// Every generator of figures should implement IFigureGenerator interface
    /// </summary>
    public interface IFigureGenerator
    {
        /// <summary>
        /// Generates a figure on a given position on the field
        /// </summary>
        /// <param name="position">A position object representing the generated figures position on the field</param>
        /// <returns>A new generated figure</returns>
        Figure GenerateFigure(Position position);
    }
}
